package cz.upol.jj2.lab09.cars;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Třídá s konfigurací celé aplikace (anotace @Configuration)
 * Zde jen "databáze".
 * Načítá ji úvodní anotace @SpringBootApplication
 */
@Configuration
public class AppConfiguration {

    //bean s prázdnou databází, qualifier je jeho jméno při navazování
    @Bean
    @Qualifier("empty")
    SimpleDatabase emptyDB() {
        return SimpleDatabase.emptyDBFactory();
    }

    //bean s přednaplněnou databází, qualifier je jeho jméno při navazování
    //vytvoří se jen jedna instance sdílená přes všechna použití
    @Bean
    @Qualifier("prefilled")
    SimpleDatabase prefilledDB() {
        return SimpleDatabase.prefilledDBFactory();
    }


}