package cz.upol.jj2.lab09.cars;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

/* naivni klient (pro ty, kteri nechteji pouzivat curl)
 */
public class Client {

    public static void main(String[] args) throws URISyntaxException, IOException, InterruptedException {

        URI postURI = new URI("http://localhost:8888/person");
        URI getURI = new URI("http://127.0.0.1:8888/person?id=1");

        HttpClient httpClient = HttpClient.newBuilder().build();
        HttpRequest.Builder reqBuilder = HttpRequest.newBuilder();

        HttpRequest getRequest = reqBuilder.uri(getURI).GET().build();
        HttpResponse<String> getResponse = httpClient.send(getRequest, HttpResponse.BodyHandlers.ofString());
        System.out.println("GET:" + getResponse.body());

        String postRequestBody = "{\"id\":10,\"name\":\"Spock\", \"surname\":\"Of Vulcan\", \"born\":\"2000-01-01\"}";
        HttpRequest postRequest = reqBuilder
                                        .uri(postURI)
                                        .setHeader("Content-Type", "application/json")
                                        .POST(HttpRequest.BodyPublishers.ofString(postRequestBody))
                                        .build();

        HttpResponse<String> postResponse = httpClient.send(postRequest, HttpResponse.BodyHandlers.ofString());
        System.out.println("POST" + postResponse.body());
    }
}
